// rand-ngon-cgal.cpp
// MCS 481 project 2 description version 1.0
#include <iostream>
#include <cstdlib>
#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/point_generators_2.h>
#include <CGAL/Polygon_2.h>
#include <CGAL/random_polygon_2.h>

typedef CGAL::Exact_predicates_inexact_constructions_kernel K;
typedef K::Point_2 Point;
typedef CGAL::Polygon_2<K> Polygon;
typedef CGAL::Creator_uniform_2<double, Point> Creator;
typedef CGAL::Random_points_in_square_2<Point, Creator> Point_generator;
typedef Polygon::Vertex_iterator VertexIterator;

using namespace std;

int main(int argc, char *argv[])
{
  Polygon pgn;
  int nv = 5;  // Default number of vertices

  // First command-line argument is number of verices
  if (argc > 1)
    nv = atoi(argv[1]);

  CGAL::random_polygon_2(nv, std::back_inserter(pgn), Point_generator(1.0));

  // Print the vertices
  for (VertexIterator vi = pgn.vertices_begin(); vi != pgn.vertices_end(); ++vi) {
    cout << *vi << endl;
  }
  return 0;
}
